bug-coreutils
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

touch: don't reject "60" as number of seconds in a legacy time stamp


From: Jim Meyering
Subject: touch: don't reject "60" as number of seconds in a legacy time stamp
Date: Mon, 14 Sep 2009 15:37:43 +0200

This change accompanies the one I just made in gnulib
to fix the underlying problem in posixtm.
Here, I've just documented the change in behavior
and added a test case.

>From df84346ebc2a359f58c914488a08462dfe293f76 Mon Sep 17 00:00:00 2001
From: Jim Meyering <address@hidden>
Date: Mon, 14 Sep 2009 14:54:23 +0200
Subject: [PATCH 1/2] build: update gnulib submodule to latest, for fixed 
posixtm module

---
 gnulib |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

diff --git a/gnulib b/gnulib
index 10322ac..6c9f1e8 160000
--- a/gnulib
+++ b/gnulib
@@ -1 +1 @@
-Subproject commit 10322ac9be1c64eb8878136c106d47f8cdd31ec4
+Subproject commit 6c9f1e88ada406b65f6b10098b8c9e60c973e614
--
1.6.5.rc1.171.g3f463


>From 20761ce686a15fa97353fd78b663bfd933840fc2 Mon Sep 17 00:00:00 2001
From: Jim Meyering <address@hidden>
Date: Sat, 12 Sep 2009 14:00:32 +0200
Subject: [PATCH 2/2] touch: don't reject "60" as number of seconds in a legacy 
time stamp

A valid command like "touch -t 197101010000.60 F" would fail due
to the suffix of ".60".  This bug is fixed via the latest change
to gnulib's posixtm module.
* tests/touch/60-seconds: New test.
* tests/Makefile.am (TESTS): Add it.
* NEWS (Bug fixes): Mention it.
---
 NEWS                   |    3 +++
 tests/Makefile.am      |    1 +
 tests/touch/60-seconds |   38 ++++++++++++++++++++++++++++++++++++++
 3 files changed, 42 insertions(+), 0 deletions(-)
 create mode 100755 tests/touch/60-seconds

diff --git a/NEWS b/NEWS
index 30f3144..963ea43 100644
--- a/NEWS
+++ b/NEWS
@@ -8,6 +8,9 @@ GNU coreutils NEWS                                    -*- 
outline -*-
   when the source file doesn't have write access.
   [bug introduced in coreutils-7.1]

+  touch -t [[CC]YY]MMDDhhmm[.ss] now accepts a timestamp string ending in .60,
+  to accommodate leap seconds.
+
 ** Changes in behavior

   id no longer prints SELinux " context=..." when the POSIXLY_CORRECT
diff --git a/tests/Makefile.am b/tests/Makefile.am
index 43a493f..63e60c8 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -436,6 +436,7 @@ TESTS =                                             \
   tail-2/pipe-f2                               \
   tail-2/proc-ksyms                            \
   tail-2/start-middle                          \
+  touch/60-seconds                             \
   touch/dangling-symlink                       \
   touch/dir-1                                  \
   touch/fail-diag                              \
diff --git a/tests/touch/60-seconds b/tests/touch/60-seconds
new file mode 100755
index 0000000..b13ad06
--- /dev/null
+++ b/tests/touch/60-seconds
@@ -0,0 +1,38 @@
+#!/bin/sh
+# touch -t would mistakenly reject a time specifying "60" seconds
+
+# Copyright (C) 2009 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+  set -x
+  touch --version
+fi
+
+. $srcdir/test-lib.sh
+
+echo 60 > exp || framework_failure
+
+fail=0
+
+# Before coreutils-7.7, this would fail, complaining of
+# an `invalid date format'.  Specifying 60 seconds *is* valid.
+TZ=UTC0 touch -t 197001010000.60 f || fail=1
+
+stat --p='%Y\n' f > out || fail=1
+
+compare out exp || fail=1
+
+Exit $fail
--
1.6.5.rc1.171.g3f463




reply via email to

[Prev in Thread] Current Thread [Next in Thread]